{
    FIREAMMO [pistolbullet] // Projectile fired by pawn
    FIREEFFECT [Electric] // muzzleflash effect
    WEAPONMODEL [Laser] // Weapon held by pawn
    FIRERATE [0.1] // Weapon firing rate
    GROUP [Friendly] // Pawn Group - must be targetted by enemies
    PLAYERSPEED [200] // Walk Speed
    HEALTHATTRIB [health] // health attribute given to pawn
    HEALTHAMOUNT [500] // amount of health given to pawn
    DAMAGEATTRIB [health] // Atribute damaged by pawn
    BOX [24] // Box width
    
    IDLEANIM [Idle] // Idle AnimationSpeed
    SHOOTANIM [Shoot3] // Shoot anim
    WALKANIM [Walk] // Walk anim
    BACKANIM [Walk] // walk back anim
	RUNANIM [Run] //Run anim
	JUMPANIM [Jump] //Jump anim
    STRAFELEFT [recon_strafe_left] // Strafe left anim
    STRAFERIGHT [recon_strafe_right] // Strafe right anim
    INTERANIM [Hit] // Pawn interact anim
    DEATHANIM [Die] // Death Anim
    ROOTBONE [Bip01] // Pawn root bone
    WEAPONHAND [Bip01 L Hand] // Pawn weapon bone
    
    K_INTER [73] // INTERACT KEY - RIGHT MOUSE
    K_FIRE [72] // FIRE KEY - LEFT MOUSE
    K_FOR [15] // FORWARD - W
    K_BAK [27] // BACK - S
    K_LEFT [26] // STRAFE LEFT - A
    K_RIGHT [28] // STRAFE RIGHT - D
    K_RUN [36] // RUN - LEFT SHIFT KEY
	K_JUMP [46] // JUMP - SPACE
	K_LEV [34] //LEVITATE KEY - L
    
    ANIM [string] // Do Not Edit
    ANC [0] // Do Not Edit 
 	// ANC Currently Set So 0 is Idle
	// 1 is Run 2 is WalkForward 
 	// 3 is WalkBackward 4 is Strafe Left
	// 5 is Strafe Right 6 is Shoot
	// 7 is Falling
	
    LASTANC [0] // Do Not Edit
    DIR [0] // Do Not Edit
    AT [0.5] // Do Not Edit
    INTER [string] // Do Not Edit
    TM [0] // Do Not Edit
    SPEED [0] //Do Not Edit
	
	WALKRUNANIM [string] //Do Not Edit
	WALKRUNSPEED [0] //Do Not Edit
	WALKRUNANC [0] //Do Not Edit
	JUMPMODE [0] //Do Not Edit
	SPACEPRESS [0] //Do Not Edit
	STORE_Z [0] //Do Not Edit
	gravityOn [1] //Do Not Edit - Keeps track if gravity is on or off
    
Spawn[()
{
    Console(true);
    BoxWidth(BOX);
    SetGroup(GROUP);
    AttributeOrder(HEALTHATTRIB,HEALTHAMOUNT,"Die");
    LowLevel("Setup");
}]
    
Setup[()
{
    self.yaw_speed=1000;
    AnimateHold(IDLEANIM);
    ANIM=StringCopy(IDLEANIM);
	AnimationSpeed(2); 
    ANC=0;
    LASTANC=0;
	SPACEPRESS=0; //Used to separate button presses for jumps
	JUMPMODE = 0; //Default - Not currently jumping
	gravityOn = 1;  //Default - Gravity is on to start
    TM=self.time;
    self.think="RunPlayer";
}]
    
RunPlayer[()
{
    //debug(self.key_pressed);
	
	
	
	PlayerToPosition(0,0,0,true,false);
   
	PlayerRender(false);
	
    DIR=0; // Default straight
    SPEED=0; //Default - no motion
    AT=0.1; //Default
    ANC=0; //Default
 
	
	WALKRUNSPEED = Integer(PLAYERSPEED); //Default for Walking
	WALKRUNANIM = StringCopy(WALKANIM);  //Default for Walking
	WALKRUNANC = 2; //Default for Walking
    
    //handle health status
    if(self.health < 1)
    {
        HighLevel("Die");
        return 0;
    }
    
	
    //handle controls
    if(IsKeyDown(K_INTER))
    {
        //strike/interact
        AnimateBlend(INTERANIM,0.25);
        self.think="Interact";
        return 0;
    }
	
	//handle Levitation
	if(IsKeyDown(K_LEV))
	{
		Gravity(false);
		gravityOn=0;
		flymove(ConvertDegrees(90),0,(75*sin(5*self.time)));
	}
	else
	{
		Gravity(true);
		gravityOn=1;
	}
	
	//Walk & Run Code
	if(IsKeyDown(K_RUN))
	{
		WALKRUNSPEED = Integer(PLAYERSPEED)*2;
		WALKRUNANIM = StringCopy(RUNANIM);
		WALKRUNANC = 1;
	}
    
	
	if((IsKeyDown(K_FOR)=true) and (IsKeyDown(K_LEFT)=false) and (IsKeyDown(K_RIGHT)=false) and (IsKeyDown(K_BAK)=false))
    {
		DIR = self.player_yaw + ConvertDegrees(180);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);
    }

    if((IsKeyDown(K_FOR)=false) and (IsKeyDown(K_LEFT)=false) and (IsKeyDown(K_RIGHT)=false) and (IsKeyDown(K_BAK)=true))
    {
		DIR = self.player_yaw;
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }

    if((IsKeyDown(K_FOR)=false) and (IsKeyDown(K_LEFT)=true) and (IsKeyDown(K_RIGHT)=false) and (IsKeyDown(K_BAK)=false))
    {
		DIR = self.player_yaw + ConvertDegrees(-90);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);
    }

    if((IsKeyDown(K_FOR)=false) and (IsKeyDown(K_LEFT)=false) and (IsKeyDown(K_RIGHT)=true) and (IsKeyDown(K_BAK)=false))
    {
		DIR = self.player_yaw + ConvertDegrees(90);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }

	 if((IsKeyDown(K_FOR)=true) and (IsKeyDown(K_LEFT)=false) and (IsKeyDown(K_RIGHT)=true) and (IsKeyDown(K_BAK)=false))
    {
		DIR = self.player_yaw + ConvertDegrees(135);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }
	
	 if((IsKeyDown(K_FOR)=true) and (IsKeyDown(K_LEFT)=true) and (IsKeyDown(K_RIGHT)=false) and (IsKeyDown(K_BAK)=false))
    {
		DIR = self.player_yaw + ConvertDegrees(-135);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }
	
	 if((IsKeyDown(K_FOR)=false) and (IsKeyDown(K_LEFT)=false) and (IsKeyDown(K_RIGHT)=true) and (IsKeyDown(K_BAK)=true))
    {
		DIR = self.player_yaw + ConvertDegrees(45);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }
	
	 if((IsKeyDown(K_FOR)=false) and (IsKeyDown(K_LEFT)=true) and (IsKeyDown(K_RIGHT)=false) and (IsKeyDown(K_BAK)=true))
    {
		DIR = self.player_yaw + ConvertDegrees(-45);
		self.ideal_yaw = DIR;
		ChangeYaw();
        ANIM=StringCopy(WALKRUNANIM);
		ANC=Integer(WALKRUNANC);
        SPEED=Integer(WALKRUNSPEED);

    }
	
	
	//handle jump - Double Jump!
	//Are we falling? If not we should be on the ground so we should we are not jumping!
	if((self.IsFalling=true) and (gravityOn=1))
	{
		ANC=7; //Set Jump/Fall animation
	}
	if((self.IsFalling=false))
	{
		JUMPMODE=0;
	}
	
	
	if((IsKeyDown(K_JUMP)=false) and (SPACEPRESS=1)){SPACEPRESS=0;} //Makes sure you have to release and re-press the jump button to jump again.
	if((IsKeyDown(K_JUMP)=true) and (SPACEPRESS=0) and (JUMPMODE < 2) and (gravityOn=1)) //Have we performed less than 2 jumps? If so run the jump function.
	{
		SPACEPRESS=1;
		HighLevel("JumpFunc");
		ANC=7; //Set Jump/Fall animation
		return 0;
	}
	
	if(ANC=7)
	{	
		//While jumping, play this anim, even if doing other actions like moving forward.
		ANIM=StringCopy(JUMPANIM);
	}
    if(ANC < 1)
    {
        //no button
        ANIM=StringCopy(IDLEANIM);
        AT=0.5;
    }
    
      
    //handle animations
    if(Integer(LASTANC) != Integer(ANC))
    {
        AnimateBlend(ANIM,AT);
    }
    LASTANC=Integer(ANC);
    if(self.animate_at_end)
    {
        AnimateHold(ANIM);
    }
    
    //handle motions
    walkmove(DIR,SPEED);

}]

Interact[()
{
    if(self.animate_at_end)
    {
        INTER=TraceToActor(ROOTBONE,0,0,32);
        if(INTER != "FALSE")
        {
            SetEventState(INTER # "Trigger",true);
        }
        self.think="RunPlayer";
        return 0;
    }
}]

Die[()
{
  AnimateStop(DEATHANIM,0,"");  
}]

JumpFunc[()
{
	if((self.IsFalling)) //If we're falling do the code below to perform the second jump and set JUMPMODE to 2 to indicate we've performed 2 jumps
	{
		JUMPMODE = 2;
		Jump(JUMPANIM,200,true,""); 
	}
	else //If we haven't performed one jump yet do the code below to perform the first jump and set JUMPMODE to 1 to indicate we've performed 1 jump
	{
	JUMPMODE=1;
	Jump(JUMPANIM,150,true,""); 
	}
	LowLevel("RunPlayer");
	return 0;
}]

}
